## urlview 1c

=== Makefile ===
# SPDX-License-Identifier: 0BSD

# gcc -DPACKAGE=\"urlview\" -DVERSION=\"0.9\" -DHAVE_CURS_SET=1 -DHAVE_NCURSES_H=1 -DHAVE_SNPRINTF=1 -DHAVE_REGEX_H=1 -DHAVE_STDARG_H=1  -I. -I.      -g -O2 -DURLVIEW -Dunix -c urlview.c
# gcc  -g -O2 -DURLVIEW -Dunix  -o urlview  urlview.o enter.o dokey.o quote.o  -lncurses

CC ?= cc
CXX ?= c++
LOCALLOC ?=
SHELLCHECK ?= $(shell command -v shellcheck 2>/dev/null || echo @#)
NOLOCREGEN ?=
CURSESCONF ?= ncursesw6-config  # can be "pkgconf ncursesw" too
VERSION ?= $(shell git describe)
DATE_EPOCH = date $(shell date --date @0 > /dev/null 2>&1 && echo "--date @" || echo "-r ")
SOURCE_DATE_EPOCH ?= $(shell git log -1 --no-show-signature --format=%at "urlview.1.in")
MANUAL_DATE ?= $(shell $(DATE_EPOCH)$(SOURCE_DATE_EPOCH) +"%B %e, %Y")
PREFIX ?= /usr/local

DEFAULT_COMMAND ?= url_handler.sh#    Debian uses: /etc/urlview/url_handler.sh
SYSTEM_INITFILE ?= /etc/urlview.conf# Debian uses: /etc/urlview/system.urlview
DEFAULT_REGEXP  ?= ((http|https|ftp|gopher|gemini|mailto):(//)?[^ <>"\t]*|(www|ftp)[0-9]?\.[-a-z0-9.]+)[^ .,;\t\n\r<">\):]?[^, <>"\t]*[^ .,;\t\n\r<">\):]
export DEFAULT_COMMAND
export SYSTEM_INITFILE
export DEFAULT_REGEXP


ADD_L := $(shell $(CURSESCONF) --cflags 2>/dev/null) -O3 -g -Wall -Wextra

CPPFLAGS += -DNCURSES_WIDECHAR -D_GNU_SOURCE
CFLAGS   += $(ADD_L)
CXXFLAGS += $(ADD_L) -fno-exceptions -fno-rtti -std=c++2b  # c++23 isn't understood by everyone
LDLIBS   += $(shell $(CURSESCONF) --libs 2>/dev/null || echo -lncursesw)

CPPFLAGS += -DVERSION='"$(VERSION)"' -DDEFAULT_COMMAND='"$(DEFAULT_COMMAND)"' -DSYSTEM_INITFILE='"$(SYSTEM_INITFILE)"' -DDEFAULT_REGEXP='"$(shell printf '%s\n' '$(subst ','\'',$(DEFAULT_REGEXP))' | sed -e 's/\\\([^nrtf]\)/\\\\\1/g' -e 's/"/\\"/g' -e "s/'/'\\\\''/g")"' -DTEXTDOMAIN_DIRNAME='"$(if $(LOCALLOC),loc,$(PREFIX)/share/locale)"'
# syntax highlighter fix: )'


ifneq (,$(shell command -v msgfmt))
	LOCALES := $(wildcard *.po)
endif

.PHONY: all check clean install

all: urlview urlview.1 sample.urlview $(patsubst %.po,loc/%/LC_MESSAGES/urlview-ng.mo,$(LOCALES))
check:
	$(SHELLCHECK) url_handler.sh
clean:
	rm -rf *.o urlview urlview.1 sample.urlview loc


loc/urlview-ng.pot: urlview.c url_handler.sh
	@mkdir -p $(@D)
	$(NOLOCREGEN)xgettext --from-code=UTF-8 -c -io- $^ | sed -n '/^#[:.]/,$$p' > $@
	$(NOLOCREGEN)$(foreach l,$(LOCALES),msgmerge --backup=off --no-wrap -Uiq $(l) $@ &&) :
	@>> loc/urlview-ng.pot

loc/%/LC_MESSAGES/urlview-ng.mo : %.po loc/urlview-ng.pot
	@mkdir -p $(@D)
	msgfmt --statistics --check-format --check-domain -o $@ $<

ifneq (,$(findstring /,$(DEFAULT_COMMAND)))
  DEFAULT_COMMAND_DEST := $(DESTDIR)$(DEFAULT_COMMAND)
else
  DEFAULT_COMMAND_DEST := $(DESTDIR)$(PREFIX)/bin/$(DEFAULT_COMMAND)
endif
install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin $(dir $(DEFAULT_COMMAND_DEST) $(DESTDIR)$(SYSTEM_INITFILE)) $(DESTDIR)$(PREFIX)/share/man/man1 $(DESTDIR)$(PREFIX)/share/locale
	cp urlview $(DESTDIR)$(PREFIX)/bin
	cp url_handler.sh $(DEFAULT_COMMAND_DEST)
	[ -e "$(DESTDIR)$(SYSTEM_INITFILE)" ] || cp sample.urlview $(DESTDIR)$(SYSTEM_INITFILE)
	cp urlview.1 $(DESTDIR)$(PREFIX)/share/man/man1
ifneq (,$(LOCALES))
	cp -r $(patsubst %.po,loc/%,$(LOCALES)) $(DESTDIR)$(PREFIX)/share/locale
endif

%: %.in
	awk '{gsub(/@DEFAULT_COMMAND@/, ENVIRON["DEFAULT_COMMAND"]); gsub(/@SYSTEM_INITFILE@/, ENVIRON["SYSTEM_INITFILE"]); if(/@DEFAULT_REGEXP@/) { gsub(/@DEFAULT_REGEXP@/, ENVIRON["DEFAULT_REGEXP"]); $(DEFAULT_REGEXP_SPECIAL); } $(AWKADD) print}' < $< > $@
urlview.1: DEFAULT_REGEXP_SPECIAL=gsub(/\\/, "\\\\")
urlview.1: AWKADD=gsub(/ \^/, " \\(ha"); gsub(/ ~/, " \\(ti"); if($$1 == ".Dd") $$2 = "$(MANUAL_DATE)"; if($$1 == ".Dt") print ".ds doc-volume-operating-system"; if($$1 == ".Os") $$2 = "urlview-ng $(VERSION)";

urlview: urlview.o enter.o enter.o dokey.o quote.o
urlview.o dokey.o enter.o: enter.h
urlview.o quote.o:         quote.h

## urlview 0.9

=== debian/changelog ===
urlview (0.9-23.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Replace CI config with central one.
  * Convert to 3.0 source format.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set debhelper-compat version in Build-Depends.

 -- Bastian Germann <bage@debian.org>  Sat, 03 Dec 2022 20:02:23 +0100

urlview (0.9-23) unstable; urgency=medium

  [ Emanuele Rocca ]
  * d/url_handler.sh: properly use nohup or suppress STDERR.
    Thanks Daniel Reichelt for the patch. Closes: #933388
  * d/README.Debian: do not mention mimedecode, the package has been removed a
    while ago. Closes: #693785
  * Allow dumping URLs to stdout by setting the URLVIEW_DEBUG environment
    variable. Thanks Francois Lallart. Closes: #598508
  * Fix warning about implicit declaration of function 'quote'.
    Thanks Joshua Root for the patch.
  * Enable Salsa CI Pipeline.
  * Add autopkgtests.
  * d/control: set Standards-Version to 4.6.1.

  [ наб ]
  * d/url_handler.sh: do not require bash for no reason, shellcheck-clean
  * d/README.Debian: align with reality w.r.t. url_handler.sh
    Closes: #1017562
  * d/control: depend on libcurses-dev directly
  * Link against libncursesw, fixing display of non-ASCII URLs
    Closes: #1017569

 -- Emanuele Rocca <ema@debian.org>  Sat, 20 Aug 2022 22:17:46 +0200

urlview (0.9-22) unstable; urgency=medium

  [ Emanuele Rocca ]
  * Move to dh and dh-autoreconf Closes: #993875
  * Drop build dependencies on: linuxdoc-tools, cdbs, libtool, automake1.11,
    autoconf, automake
  * Invoke AM_INIT_AUTOMAKE with "foreign"
  * Set debhelper compatibility level to 13
  * Add debian/source/format
  * Do not ship SGML and HTML version of the man page, remove
    debian/htmlworkaround and doc-base control file
  * Drop debian/watch file, ftp.mutt.org does not have any upstream tarballs
    anymore

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces

 -- Emanuele Rocca <ema@debian.org>  Thu, 16 Sep 2021 12:02:11 +0200

urlview (0.9-21) unstable; urgency=medium

  * Use aclocal-1.16. Closes: #906513
  * url_handler.sh uses sensible-browser, add dependency on sensible-utils.
  * Set debhelper compatibility level to 10.
  * Add Vcs-{Browser,Git} poiting to salsa.
  * Update Standards-Version to 4.2.0.

 -- Emanuele Rocca <ema@debian.org>  Sun, 19 Aug 2018 15:00:03 +0200

urlview (0.9-20) unstable; urgency=medium

  * Invoke automake with --add-missing and bump DEB_AUTO_UPDATE_ACLOCAL to
    1.15. Closes: #818411
  * Build-depend on automake.
  * Pass -n to gzip to allow reproducible builds.
  * Set Standards-Version to 3.9.7.

 -- Emanuele Rocca <ema@debian.org>  Thu, 24 Mar 2016 11:40:48 +0100

urlview (0.9-19) unstable; urgency=low

  * Acknowledge NMU. Thanks, Matt Kraai!
  * Alpine added to mailto_prgs. Closes: #521049
  * Mimedecode removed from "Suggests". Closes: #550885, #597426
  * ncftp2 has been renamed to ncftp. "Suggests" changed accordingly.
  * Standards-Version bumped to 3.9.1:
    - Added {misc:Depends} to "Depends".
    - Debhelper compatibility level set to 8, build-depend on debhelper >= 8.
    - Extra leading whitespaces removed from doc-base control file.
    - Removed debian/postinst as calling install-docs is not required anymore.
    - Fixed debian/NEWS syntax errors.
    - doc-base section changed to Text.

 -- Emanuele Rocca <ema@debian.org>  Sat, 12 Mar 2011 20:42:01 +0100

urlview (0.9-18.1) unstable; urgency=low

  * Non-maintainer upload.
  * Change DEB_AUTO_UPDATE_ACLOCAL from 1.10 to 1.11 and build-depend on
    automake1.11 instead of automake. Closes: #543023

 -- Matt Kraai <kraai@debian.org>  Tue, 29 Sep 2009 06:08:26 -0700

urlview (0.9-18) unstable; urgency=low

  * Build-depend on automake instead of automake1.8. Closes: #474078
  * BROWSER convention url updated in README. Closes: #438953
  * Updated Standards-Version.

 -- Emanuele Rocca <ema@debian.org>  Sun, 06 Apr 2008 11:00:07 +0200

urlview (0.9-17) unstable; urgency=low

  * Use sensible-browser rather than www-browser in url_handler.sh.
  * Updated Standards-Version.

 -- Emanuele Rocca <ema@debian.org>  Sun, 29 Jul 2007 15:41:17 +0200

urlview (0.9-16) unstable; urgency=low

  * Wrapping disabled by default.
    Added WRAP configuration option. Closes: #327850
  * Debian REGEXP and COMMAND hardcoded in urlview.c Closes: #322432
  * Switched from simple-patchsys (cdbs) to darcs-buildpackage:
     - debian/patches/ directory removed
     - call to simple-patchsys.mk removed
  * Standards-Version updated
  * Address of the FSF updated in debian/copyright

 -- Emanuele Rocca <ema@debian.org>  Wed, 05 Oct 2005 18:35:52 +0200

urlview (0.9-15) unstable; urgency=low

  * Patched to support url pre-selection.
    Thanks to Kim Oldfield for the patch. Closes: #108581

 -- Emanuele Rocca <ema@debian.org>  Thu,  9 Jun 2005 12:40:24 +0200

urlview (0.9-14) experimental; urgency=low

  * Patched to support wrapping.
    Thanks to Martin Michlmayr for the patch. Closes: #307576

 -- Emanuele Rocca <ema@debian.org>  Sun, 05 Jun 2005 15:07:33 +0200

urlview (0.9-13) experimental; urgency=low

  * Missing build dependencies added: libtool, automake1.8, autoconf.
    Thanks, Kenshi Muto. Closes: #309169
  * Patched to support page up and page down also with few results.
    Closes: #307577
  * Changed 'Recommends' to: elinks | www-browser to make lintian happy.

 -- Emanuele Rocca <ema@debian.org>  Sun, 15 May 2005 12:37:24 +0200

urlview (0.9-12) experimental; urgency=low

  * Switched to CDBS
    - debian/rules rewritten to support CDBS
    - changes from the pristine tarball splitted and added to debian/patches
    - debhelper versioned build-dependency bumped to 4.1.0
  * Watch file added

 -- Emanuele Rocca <ema@debian.org>  Wed,  4 May 2005 21:49:24 +0200

urlview (0.9-11) unstable; urgency=low

  * debian/url_handler.sh:
    Added support for RFC 2368 urls (mailto URL scheme).
    Closes:#233066

 -- Emanuele Rocca <ema@debian.org>  Mon, 16 Feb 2004 14:36:09 +0100



=== debian/control ===
Source: urlview
Section: misc
Priority: optional
Maintainer: Emanuele Rocca <ema@debian.org>
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian/urlview
Vcs-Git: https://salsa.debian.org/debian/urlview.git
Build-Depends: libncurses-dev, debhelper-compat (= 13)

Package: urlview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, sensible-utils
Recommends: elinks | www-browser
Suggests: mutt, ncftp | lftp, wget | snarf
Description: Extracts URLs from text
 This utility is used to extract URL from text files, especially from mail
 messages in order to launch some browser to view them. This used to be a
 part of mutt but has now become an independent tool.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --mandir=$(CURDIR)/debian/urlview/usr/share/man

override_dh_auto_install:
	dh_auto_install
	install -m 644 debian/system.urlview \
	               debian/urlview/etc/urlview/system.urlview
	install -m 755 debian/url_handler.sh \
		       debian/urlview/etc/urlview/url_handler.sh

=== debian/tests/control ===
Tests: nourls, urlextract
Depends: urlview

## urlview 1c

=== debian/changelog ===
urlview (1c-1) unstable; urgency=medium

  * d/control: drop the ill-conceived shellcheck dep
  * Downgrade sensible-utils to Recommends: ‒
    very-nice-to-have in default configuration,
    but by no means absolutely required (Closes: #906725)
  * Revert UCF addition (Closes: #1057675)
  * New upstream version 1c (+ changelog & NEWS) (Closes: #1057411, #1043334)
  * d/copyright: update for 1c

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Mon, 11 Dec 2023 13:12:26 +0100

urlview (1b-1) unstable; urgency=medium

  * New maintainer (Closes: #1051204)
  * d/watch, d/upstream/signing-key.asc: new for urlview-ng upstream
  * New upstream version 1b (+ changelog & NEWS)
    (Closes: #127090, #161620, #631481, #690405, #983417, #985259, #988055)
  * d/system.urlview, d/url_handler.sh, d/patches: remove, merged upstream
  * d/postrm, d/dhelp, d/README.Debian: remove
  * d/tests: rewrite
  * d/rules, d/copyright: new for urlview-ng
  * d/upstream/metadata: add for urlview-ng

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sun, 26 Nov 2023 23:17:53 +0100

urlview (0.9-24) unstable; urgency=medium

  * Goodbye urlview! Set maintainer field to QA Group.

 -- Emanuele Rocca <ema@debian.org>  Mon, 04 Sep 2023 15:06:08 +0200

=== debian/control ===
Source: urlview
Section: misc
Priority: optional
Maintainer: наб <nabijaczleweli@nabijaczleweli.xyz>
Standards-Version: 4.6.2
Homepage: https://sr.ht/~nabijaczleweli/urlview-ng
Rules-Requires-Root: no
Vcs-Git: https://git.sr.ht/~nabijaczleweli/urlview.deb
Vcs-Browser: https://git.sr.ht/~nabijaczleweli/urlview.deb
Build-Depends: debhelper,
               debhelper-compat (= 13),
               libncurses-dev,
               gettext <!pkg.urlview.noloc>,

Package: urlview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: sensible-utils, elinks | www-browser
Suggests: mutt | neomutt, ncftp | lftp, wget | curl | snarf
Description: Extracts URLs from text
 This utility is used to extract URL from text files, especially from mail
 messages in order to launch some browser to view them. This used to be a
 part of mutt but has now become an independent tool.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export DEB_BUILD_OPTIONS += notrimdch


export PREFIX := /usr
export DEFAULT_COMMAND := /etc/urlview/url_handler.sh
export SYSTEM_INITFILE := /etc/urlview/system.urlview
export NOLOCREGEN := @\#
export VERSION := $(shell IFS="$$IFS()" read -r _ v _ < debian/changelog && echo "$$v")
export TZ := UTC0


override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs README
	cp debian/NEWS.upstream debian/urlview/usr/share/doc/urlview/NEWS


%:
	dh $@

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s:$:.asc:" \
	https://git.sr.ht/~nabijaczleweli/urlview-ng/refs .*/([0-9][0-9a-zA-Z]*)@ARCHIVE_EXT@

## urlview 1d

=== Makefile ===
--- 
+++ 
@@ -8,9 +8,9 @@
 LOCALLOC ?=
 SHELLCHECK ?= $(shell command -v shellcheck 2>/dev/null || echo @#)
 NOLOCREGEN ?=
-CURSESCONF ?= ncursesw6-config  # can be "pkgconf ncursesw" too
+CURSESCONF ?= ncursesw6-config  # can be "pkgconf ncursesw" too, or "echo -lcurses #"
 VERSION ?= $(shell git describe)
-DATE_EPOCH = date $(shell date --date @0 > /dev/null 2>&1 && echo "--date @" || echo "-r ")
+DATE_EPOCH = date $(shell date -d @0 > /dev/null 2>&1 && echo "-d @" || echo "-r ")
 SOURCE_DATE_EPOCH ?= $(shell git log -1 --no-show-signature --format=%at "urlview.1.in")
 MANUAL_DATE ?= $(shell $(DATE_EPOCH)$(SOURCE_DATE_EPOCH) +"%B %e, %Y")
 PREFIX ?= /usr/local
@@ -41,10 +41,11 @@
 .PHONY: all check clean install
 
 all: urlview urlview.1 sample.urlview $(patsubst %.po,loc/%/LC_MESSAGES/urlview-ng.mo,$(LOCALES))
-check:
+check: quote
 	$(SHELLCHECK) url_handler.sh
+	./quote
 clean:
-	rm -rf *.o urlview urlview.1 sample.urlview loc
+	rm -rf *.o urlview quote urlview.1 sample.urlview loc
 
 
 loc/urlview-ng.pot: urlview.c url_handler.sh
@@ -80,3 +81,7 @@
 urlview: urlview.o enter.o enter.o dokey.o quote.o
 urlview.o dokey.o enter.o: enter.h
 urlview.o quote.o:         quote.h
+
+quote: CPPFLAGS+=-DTEST
+quote: quote.cpp
+	$(CXX) $(CPPFLAGS) $(CXXFLAGS) $(LDFLAGS) $< $(LOADLIBES) $(LDLIBS) -o $@

=== debian/changelog ===
urlview (1d-1) unstable; urgency=medium

  * New upstream version 1d (+ changelog & NEWS)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Fri, 16 Feb 2024 13:30:25 +0100

## urlview 1e

=== Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 NOLOCREGEN ?=
 CURSESCONF ?= ncursesw6-config  # can be "pkgconf ncursesw" too, or "echo -lcurses #"
 VERSION ?= $(shell git describe)
-DATE_EPOCH = date $(shell date -d @0 > /dev/null 2>&1 && echo "-d @" || echo "-r ")
+DATE_EPOCH = LC_ALL=C date $(shell date -d @0 > /dev/null 2>&1 && echo "-d @" || echo "-r ")
 SOURCE_DATE_EPOCH ?= $(shell git log -1 --no-show-signature --format=%at "urlview.1.in")
 MANUAL_DATE ?= $(shell $(DATE_EPOCH)$(SOURCE_DATE_EPOCH) +"%B %e, %Y")
 PREFIX ?= /usr/local
@@ -52,7 +52,7 @@
 	@mkdir -p $(@D)
 	$(NOLOCREGEN)xgettext --from-code=UTF-8 -c -io- $^ | sed -n '/^#[:.]/,$$p' > $@
 	$(NOLOCREGEN)$(foreach l,$(LOCALES),msgmerge --backup=off --no-wrap -Uiq $(l) $@ &&) :
-	@>> loc/urlview-ng.pot
+	@>> $@
 
 loc/%/LC_MESSAGES/urlview-ng.mo : %.po loc/urlview-ng.pot
 	@mkdir -p $(@D)

=== debian/changelog ===
urlview (1e-1) unstable; urgency=medium

  * New upstream version 1e (+ changelog & NEWS)
  * Suggests: xclip | xsel | wl-clipboard
  * Standards-Version: 4.6.2 -> 4.7.0
  * lintian update-debian-copyright

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sun, 06 Oct 2024 17:09:36 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: наб <nabijaczleweli@nabijaczleweli.xyz>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://sr.ht/~nabijaczleweli/urlview-ng
 Rules-Requires-Root: no
 Vcs-Git: https://git.sr.ht/~nabijaczleweli/urlview.deb
@@ -16,7 +16,7 @@
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: sensible-utils, elinks | www-browser
-Suggests: mutt | neomutt, ncftp | lftp, wget | curl | snarf
+Suggests: mutt | neomutt, ncftp | lftp, wget | curl | snarf, xclip | xsel | wl-clipboard
 Description: Extracts URLs from text
  This utility is used to extract URL from text files, especially from mail
  messages in order to launch some browser to view them. This used to be a

=== debian/tests/control ===
Tests: nourls
Depends: @, bsdutils

Tests: urlextract
